package com.company;

import java.io.*;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;

/**
 * a class to read and write notes and save them
 */
public class NoteReader {
    private ArrayList<String> titles;
    private ArrayList<String> bodies;

    /**
     * constructor for the class allocates memory and reads notes
     */
    public NoteReader(){
        titles = new ArrayList<>();
        bodies = new ArrayList<>();
        readNotesFile();
//        readNotesBuffer();
    }

    /**
     * reads notes using buffer reader
     */
    public void readNotesBuffer(){
        titles.clear();
        bodies.clear();
        FileReader fr = null;
        try {
            fr = new FileReader("notes.txt");
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        BufferedReader br = new BufferedReader(fr);
        String title;
        try {
            while ((title = br.readLine()) != null){
                titles.add(title);
                bodies.add(br.readLine());
            }
            br.close();
            fr.close();
        }catch (IOException e){
            e.printStackTrace();
        }
    }

    /**
     * adds a note using bufferwriter
     * @param title String  title of the note
     * @param body String  body of the note
     */
    public void addNoteBuffer(String title,String body){
        titles.add(title);
        bodies.add(body);
        FileWriter fw = null;
        try {
            fw = new FileWriter("notes.txt");
        } catch (IOException e) {
            e.printStackTrace();
        }
        BufferedWriter bw = new BufferedWriter(fw);
        for(int i = 0;i<titles.size();i++){
            try {
                bw.write(titles.get(i)+"\n");
                bw.write(bodies.get(i)+"\n");
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        try {
            bw.close();
            fw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * reads the notes using file stream
     */
    public void readNotesFile(){
        FileInputStream fi = null;
        try {
            fi = new FileInputStream("notes.txt");
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        int x;
        StringBuffer title = new StringBuffer();
        StringBuffer body = new StringBuffer();
        try {
            while ((x = fi.read()) != -1){
                title.delete(0,title.length());
                body.delete(0,body.length());
                title.append((char) x);
                while ((x = fi.read()) != '\n'){
                    title.append((char) x);
                }
                while ((x = fi.read()) != '\n'){
                    body.append((char) x);
                }
                titles.add(title.toString());
                bodies.add(body.toString());
            }
            fi.close();
        }catch (IOException e){
            e.printStackTrace();
        }
    }

    /**
     * adds a new note usng file stream
     * @param title String  title of the note
     * @param body String  body of the note
     */
    public void addNoteFile(String title,String body){
        titles.add(title);
        bodies.add(body);
        FileOutputStream fo = null;
        try {
            fo = new FileOutputStream("notes.txt");
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        try {
            byte[] b;
            for(int i = 0;i<titles.size();i++){
                b = (titles.get(i)+"\n").getBytes();
                fo.write(b);
                b = (bodies.get(i)+"\n").getBytes();
                fo.write(b);
            }
            fo.close();
        }catch (IOException e){
            e.printStackTrace();
        }

    }

    /**
     * prints all notes
     */
    public void printNotes(){
        int i;
        for(i=0;i<titles.size();i++){
            System.out.println(titles.get(i));
            System.out.println(bodies.get(i));
        }
        System.out.println();
    }
}
