package com.company;

import java.io.*;
import java.util.ArrayList;

/**
 * reads and writes notes as objects
 */
public class ObjectNotes {
    private ArrayList<Note> notes;

    /**
     * constructor of the class allocates memory
     */
    public ObjectNotes(){
        notes = new ArrayList<>();
    }

    /**
     * reads the notes from the file
     */
    public void readNotes(){
        notes.clear();
        try {
            FileInputStream fo = new FileInputStream("notes.bin");
            ObjectInputStream o = new ObjectInputStream(fo);
            while (true){
                try {
                    notes.add((Note)o.readObject());

                }catch (EOFException e){
                    o.close();
                    fo.close();
                    return;
                }
            }
        } catch (IOException | ClassNotFoundException e) {
            e.printStackTrace();
        }
    }

    /**
     * adds a new note
     * @param note Note  ne note to be added
     */
    public void addNote(Note note){
        readNotes();
        notes.add(note);
        try {
            FileOutputStream f = new FileOutputStream("notes.bin");
            ObjectOutputStream o = new ObjectOutputStream(f);
            for (Note n : notes){
                o.writeObject(n);
            }
            o.close();
            f.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * removes an existing note
     * @param index int  index of the note to be removed
     */
    public void removeNote(int index){
        readNotes();
        notes.remove(index);
        try {
            FileOutputStream f = new FileOutputStream("notes.bin");
            ObjectOutputStream o = new ObjectOutputStream(f);
            for (Note n : notes){
                o.writeObject(n);
            }
            o.close();
            f.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public ArrayList<Note> getNotes(){
        readNotes();
        return notes;
    }

    /**
     * prints all notes
     */
    public void printNotes(){
        readNotes();
        for(Note n : notes){
            System.out.print(n);
        }
        System.out.println();
    }
}
